package pl.amu.edu.demo.data;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.ToString;
import lombok.experimental.FieldDefaults;

import java.time.LocalDate;
import java.util.Objects;

@AllArgsConstructor(access = AccessLevel.PRIVATE)
@FieldDefaults(level = AccessLevel.PUBLIC, makeFinal = true)
@Builder
@ToString
public class Person {
    String displayName;
    String firstName;
    String lastName;
    LocalDate birthDate;
    Housing housing;
    boolean isMarried;

    public int getAge() {
        var birthYear = Objects.requireNonNull(birthDate).getYear();
        var now = LocalDate.now();
        var baseDifference = now.getYear() - birthYear;
        if (birthDate.getMonthValue() > now.getMonthValue() ||
                (birthDate.getMonthValue() == now.getMonthValue() &&
                        birthDate.getDayOfMonth() <= now.getDayOfMonth())) {
            return baseDifference;
        }
        return baseDifference - 1;
    }

}
