package pl.amu.edu.demo.logic;

import lombok.AccessLevel;
import lombok.RequiredArgsConstructor;
import lombok.experimental.FieldDefaults;
import pl.amu.edu.demo.data.Housing;
import pl.amu.edu.demo.data.WeWillStealYourFlatCheckResult;

@RequiredArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE, makeFinal = true)
public class ApartmentHousingStrategy implements HousingStrategy {

    NetWorthCalculator calculator;
    NetWorthDecider decider;

    @Override
    public WeWillStealYourFlatCheckResult checkEligibility(Housing housing) {
        var netWorth = calculator.calculateNetWorthForZipCode(housing.address.zipCode, housing.area);
        return decider.isEligible(netWorth);
    }

}
