package pl.amu.edu.demo.logic;

import pl.amu.edu.demo.data.Housing;
import pl.amu.edu.demo.data.WeWillStealYourFlatCheckResult;

public interface HousingStrategy {

    WeWillStealYourFlatCheckResult checkEligibility(Housing housing);

    static HousingStrategy getInstance(Housing housing, NetWorthCalculator calculator, NetWorthDecider decider) {
        return housing.isApartment ? new ApartmentHousingStrategy(calculator, decider) : new HouseHousingStrategy();
    }

}
