package pl.amu.edu.demo.logic;

import lombok.AccessLevel;
import lombok.RequiredArgsConstructor;
import lombok.ToString;
import lombok.experimental.FieldDefaults;
import pl.amu.edu.demo.providers.AverageQuoteProvider;

@RequiredArgsConstructor(staticName = "forProvider")
@FieldDefaults(level = AccessLevel.PRIVATE, makeFinal = true)
@ToString
public class NetWorthCalculator {

    AverageQuoteProvider provider;

    public double calculateNetWorthForZipCode(String zipCode, double apartmentArea) {
        return provider.getAverageQuotePerSquareMeter(zipCode) * apartmentArea;
    }
}
