package pl.amu.edu.demo.logic;

import pl.amu.edu.demo.data.Person;
import pl.amu.edu.demo.data.WeWillStealYourFlatCheckResult;
import pl.amu.edu.demo.providers.AverageQuoteProvider;

public class WeWillStealYourFlatProduct {

    private final AverageQuoteProvider provider;
    private final AgeDecider ageDecider;

    public WeWillStealYourFlatProduct(AverageQuoteProvider provider) {
        this.provider = provider;
        this.ageDecider = new AgeDecider();
    }


    public WeWillStealYourFlatCheckResult check(Person person) {
        if (!ageDecider.isEligible(person.getAge())) {
            return WeWillStealYourFlatCheckResult.NOT_ELIGIBLE;
        }
        var netWorthCalculator = NetWorthCalculator.forProvider(provider);
        var netWorthDecider = NetWorthDecider.getInstance(person.isMarried);
        var strategy = HousingStrategy.getInstance(person.housing, netWorthCalculator, netWorthDecider);
        return strategy.checkEligibility(person.housing);
    }

}
