package pl.amu.edu.demo.data;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.experimental.FieldDefaults;

import java.util.Optional;

@AllArgsConstructor(access = AccessLevel.PRIVATE)
@FieldDefaults(level = AccessLevel.PUBLIC, makeFinal = true)
@Getter
@Builder
public class Housing {
    Address address;
    boolean isApartment;
    Double area;

    public Optional<String> zipCode() {
        return Optional.ofNullable(address).map(address -> address.zipCode);
    }

}
