package pl.amu.edu.demo.data;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.experimental.FieldDefaults;

import java.time.LocalDate;
import java.util.Objects;

@AllArgsConstructor(access = AccessLevel.PRIVATE)
@FieldDefaults(level = AccessLevel.PUBLIC, makeFinal = true)
@Getter
@Builder
public class Person {
    String displayName;
    String firstName;
    String lastName;
    LocalDate birthDate;
    Housing housing;
    boolean isMarried;

    public boolean isAdult() {
        return Objects.nonNull(birthDate) &&
                LocalDate.now().minusYears(18).isAfter(birthDate);
    }

    public int getAge() {
        var birthYear = Objects.requireNonNull(birthDate).getYear();
        var now = LocalDate.now();
        var baseDifference = now.getYear() - birthYear;
        if (birthDate.getMonthValue() > now.getMonthValue() ||
                (birthDate.getMonthValue() == now.getMonthValue() &&
                        birthDate.getDayOfMonth() >= now.getDayOfMonth())) {
            return baseDifference;
        }
        return baseDifference - 1;
    }

}
