package pl.edu.amu.demo.life.dto;

import lombok.*;
import lombok.experimental.FieldDefaults;
import pl.edu.amu.demo.life.jpa.Person;

@FieldDefaults(level = AccessLevel.PRIVATE)
@AllArgsConstructor
@NoArgsConstructor
@Setter
@Getter
@EqualsAndHashCode
@ToString
public class PersonDTO {

    Long id;
    String displayName;
    String firstName;
    String lastName;
    Long clientId;

    public Person toPerson() {
        return new Person(id, displayName, firstName, lastName, clientId);
    }

    public static PersonDTO fromPerson(Person person) {
        return new PersonDTO(
                person.getId(),
                person.getDisplayName(),
                person.getFirstName(),
                person.getLastName(),
                person.getClientId()
        );
    }

}
