package pl.edu.amu.demo.life.jpa;

import lombok.*;

import javax.persistence.*;
import java.math.BigDecimal;
import java.time.LocalDate;

@Entity
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@ToString
public class Policy {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "policy_id")
    private Long id;

    @Column(name = "policy_number", unique = true, nullable = false, updatable = false)
    private String number;

    @Column(name = "policy_insured_sum", nullable = false, updatable = false)
    private BigDecimal insuredSum;

    @Column(name = "policy_start_date", nullable = false, updatable = false)
    private LocalDate startDate;

    @Column(name = "policy_end_date", nullable = false)
    private LocalDate endDate;

    @ManyToOne(cascade = CascadeType.ALL)
    private Person insuredPerson;

    @Column(name = "policy_status", nullable = false)
    private PolicyStatus status;

    @Column(name = "policy")
    private LocalDate statusChangeDate;

}
