package pl.edu.amu.demo.life.web.rest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pl.edu.amu.demo.life.dto.PersonDTO;
import pl.edu.amu.demo.life.dto.PolicyDTO;
import pl.edu.amu.demo.life.service.PolicyService;

import java.util.List;

@RestController
public class PolicyController {

    final PolicyService service;

    @Autowired
    public PolicyController(PolicyService service) {
        this.service = service;
    }

    @GetMapping(path = "/policies/count")
    public long getCount() {
        return service.countPolicies();
    }

    @GetMapping(path = "policies/list")
    public List<PolicyDTO> getAllPolicies() {
        // AGAIN, DO NOT DO THAT IN REAL LIFE!!!
        // YOU ALWAYS NEED WHERE CLAUSE WHILE QUERYING A DATABASE!!!
        return service.getAllPolicies();
    }

    @PutMapping(path = "policies/add")
    public void putNewPolicy(@RequestBody PolicyDTO policyDTO) {
        service.savePolicy(policyDTO);
    }

    @PostMapping(path = "policies/update/{policyId}")
    public void updatePolicy(@PathVariable Long policyId, @RequestBody PolicyDTO policyDTO) {
        service.updatePolicy(policyId, policyDTO);
    }

    @PostMapping(path = "person/update")
    public void updatePerson(@RequestBody PersonDTO personDTO) {
        service.updatePerson(personDTO);
    }

    @DeleteMapping(path = "person/delete/{personId}")
    public void deletePerson(@PathVariable Long personId) {
        service.deletePerson(personId);
    }

}
