package pl.edu.amu.dto;

import lombok.Builder;
import lombok.Value;
import pl.edu.amu.entity.Person;

import static java.util.Objects.isNull;

@Value
@Builder
public class Ancestors implements Comparable<Ancestors> {

    Person father;
    Person mother;
    int level;

    public Long getFatherId() {
        if (isNull(father))
            return null;
        return father.personId;
    }

    public Long getMotherId() {
        if (isNull(mother))
            return null;
        return mother.personId;
    }

    @Override
    public int compareTo(Ancestors other) {
        if (isNull(other))
            return -1;
        return Integer.compare(level, other.level);
    }

}
