package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.experimental.FieldDefaults;

@Entity
@FieldDefaults(level = AccessLevel.PUBLIC)
@Getter
public class Ancestor {

    @EmbeddedId
    AncestorKey id;

    @ManyToOne(optional = false)
    @MapsId("personId")
    @JoinColumn(name = "person_id")
    Person person;

    @ManyToOne(fetch = FetchType.EAGER)
    @MapsId("ancestorId")
    @JoinColumn(name = "ancestor_id")
    Person ancestor;

    @Column(nullable = false)
    Integer level;

    @Column(name = "ancestor_offset")
    Integer ancestorOffset;

}
