package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;

@NoArgsConstructor
@AllArgsConstructor
@Builder
@EqualsAndHashCode
@ToString
@Getter
@FieldDefaults(level = AccessLevel.PUBLIC)
@Entity
@Table(name = "event_person")
public class EventPerson {

    @EmbeddedId
    EventPersonKey id;

    @ManyToOne(optional = false, cascade = CascadeType.ALL)
    @MapsId("eventId")
    @JoinColumn(name = "event_id")
    Event event;

    @ManyToOne(optional = false, cascade = CascadeType.ALL)
    @MapsId("person_id")
    @JoinColumn(name = "person_id")
    Person person;

    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    EventPersonRole role;

    @Column
    Integer age;

    @Column
    String occupation;

    @Column
    String title;

    @Column(name = "additional_info")
    String additionalInfo;

}
