package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;

@AllArgsConstructor
@NoArgsConstructor
@Builder
@FieldDefaults(level = AccessLevel.PUBLIC)
@Entity
@Table(name = "external_identifier")
public class ExternalId {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "external_identifier_id")
    Long externalId;

    @ManyToOne
    @JoinColumn(name = "person_id")
    Person person;

    @ManyToOne
    @JoinColumn(name = "family_id")
    Family family;

    @ManyToOne(optional = false)
    @JoinColumn(name = "source_id", nullable = false)
    Source source;

    @NonNull
    @Column(nullable = false)
    String identifier;

}

