package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;

import java.time.ZonedDateTime;
import java.util.Set;

@NoArgsConstructor
@AllArgsConstructor
@Builder(builderClassName = "FamilyBuilder", toBuilder = true)
@Getter
@EqualsAndHashCode
@ToString
@FieldDefaults(level = AccessLevel.PUBLIC)
@Entity
@Table(name = "family")
public class Family {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "family_id")
    Long familyId;

    @OneToMany(mappedBy = "family")
    Set<FamilyMember> familyMembers;

    @Column(name = "creation_date", nullable = false)
    ZonedDateTime creationDate;

    @Column(name = "modification_date")
    ZonedDateTime modificationDate;

    public static final class FamilyBuilder {
        ZonedDateTime creationDate = ZonedDateTime.now();
        ZonedDateTime modificationDate = ZonedDateTime.now();
    }

}
