package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;

@AllArgsConstructor
@NoArgsConstructor
@Builder
@Getter
@EqualsAndHashCode
@ToString
@FieldDefaults(level = AccessLevel.PUBLIC)
@Entity
@Table(name = "family_member")
public class FamilyMember {

    @EmbeddedId
    FamilyPersonKey id;

    @ManyToOne
    @MapsId("familyId")
    @JoinColumn(name = "family_id")
    Family family;

    @ManyToOne
    @MapsId("personId")
    @JoinColumn(name = "person_id")
    Person person;

    @Column(name = "role", nullable = false)
    @Enumerated(EnumType.STRING)
    FamilyRole role;

}
