package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;

import java.time.ZonedDateTime;

@AllArgsConstructor
@NoArgsConstructor
@Builder
@EqualsAndHashCode
@ToString
@FieldDefaults(level = AccessLevel.PUBLIC)
@Entity
public class Source {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "source_id")
    Long sourceId;

    @Column(name = "external_id", unique = true, nullable = false)
    String externalId;

    @Column
    String uri;

    @Column(name = "source_date", nullable = false)
    ZonedDateTime sourceDate;

    @Column(name = "last_import_date", nullable = false)
    ZonedDateTime lastImportDate;

}
