package pl.edu.amu.entity;

import jakarta.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;

@NoArgsConstructor
@AllArgsConstructor
@Builder
@EqualsAndHashCode
@ToString
@FieldDefaults(level = AccessLevel.PUBLIC)
@Entity
@Table(name = "source_event")
public class SourceEvent {

    @EmbeddedId
    SourceEventKey id;

    @ManyToOne
    @MapsId("eventId")
    @JoinColumn(name = "event_id")
    Event event;

    @ManyToOne
    @MapsId("sourceId")
    @JoinColumn(name = "source_id")
    Source source;

    @Column
    String description;

    @ManyToOne
    @JoinColumn(name = "picture_id")
    Picture picture;

}
