package pl.edu.amu.entity.converter;

import jakarta.persistence.AttributeConverter;

import java.time.MonthDay;

import static java.util.Objects.isNull;

public class MontDayConverter implements AttributeConverter<MonthDay, String> {

    @Override
    public String convertToDatabaseColumn(MonthDay monthDay) {
        return isNull(monthDay) ? null : monthDay.toString();
    }

    @Override
    public MonthDay convertToEntityAttribute(String serialized) {
        return isNull(serialized) ? null : MonthDay.parse(serialized);
    }

}
