package pl.edu.amu.repository;

import jakarta.transaction.Transactional;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;
import pl.edu.amu.entity.Ancestor;
import pl.edu.amu.entity.AncestorKey;

import java.util.List;

@Repository
public interface AncestorRepository extends CrudRepository<Ancestor, AncestorKey> {

    @Modifying
    @Transactional
    @Query(value = "INSERT INTO Ancestor(person_id, ancestor_id, level, ancestor_offset) VALUES (?,?,?,?)",
           nativeQuery = true)
    void insert(Long personId, Long ancestorId, int level, int ancestorOffset);


    @Query("SELECT a from Ancestor a JOIN Person pa ON (a.ancestor = pa) WHERE a.person.personId = :personId ORDER BY a.level")
    List<Ancestor> findAllByPersonId(Long personId);

}
