package pl.edu.amu.repository;

import jakarta.transaction.Transactional;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;
import pl.edu.amu.entity.EventPerson;
import pl.edu.amu.entity.EventPersonKey;

@Repository
public interface EventPersonRepository extends CrudRepository<EventPerson, EventPersonKey> {

    @Modifying
    @Transactional
    @Query(value = "INSERT INTO event_person" +
            " (event_id, person_id, role, age, occupation, title, additional_info)" +
            " VALUES (?1, ?2, ?3, ?4, ?5, ?6, ?7)", nativeQuery = true)
    void insert(
            Long eventId,
            Long personId,
            String role,
            Integer age,
            String occupation,
            String title,
            String additionalInfo
    );

}
