package pl.edu.amu.repository;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;
import pl.edu.amu.entity.Event;
import pl.edu.amu.entity.Person;

import java.util.List;
import java.util.Optional;

@Repository
public interface EventRepository extends CrudRepository<Event, Long> {

    @Query("SELECT e FROM Event e JOIN EventPerson ep ON(e = ep.event) JOIN Person p ON (p = ep.person) WHERE p = :person")
    List<Event> findByPerson(Person person);

    @Query("""
    SELECT e
    FROM Event e
    JOIN EventPerson ep1 ON(e = ep1.event)
    JOIN EventPerson ep2 ON (e = ep2.event)
    WHERE ep1.person = :bride
    AND ep2.person = :groom
    AND e.type = 'MARRIAGE'
    """)
    Optional<Event> findMarriageByBrideGroom(Person bride, Person groom);

}
