package pl.edu.amu.web;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import pl.edu.amu.service.DbService;
import pl.edu.amu.web.data.EventUpsert;
import pl.edu.amu.web.data.PersonDisplayName;

@RestController
@Slf4j
public class UpdateController {

    @Autowired
    DbService service;

    @PostMapping(path = "/person/upsert-event")
    public void upsertEvent(@RequestBody EventUpsert eventData, @RequestParam Long descendant) {
        service.upsertEvent(eventData, descendant);
    }

    @PostMapping(path = "/person/update-display-name")
    public void updateDisplayName(@RequestBody PersonDisplayName personDisplayName) {
        service.updateDisplayName(personDisplayName);
    }

}
