package pl.edu.amu.web.data;

import lombok.Builder;
import lombok.NonNull;
import lombok.Value;
import pl.edu.amu.entity.EventType;

import java.time.LocalDate;
import java.time.MonthDay;

import static pl.edu.amu.entity.EventType.NAME_DAY;

@Value
@Builder
public class PrayerData implements Comparable<PrayerData> {

    @NonNull Long personId;
    @NonNull String displayName;
    @NonNull LocalDate eventDate;
    @NonNull EventType eventType;
    int level;
    boolean dateKnown;
    boolean done;
    Long prayerId;


    @Override
    public int compareTo(PrayerData other) {
        int byDate = MonthDay.from(eventDate).compareTo(MonthDay.from(other.eventDate));
        if (byDate != 0) return byDate;
        int byYearDesc = -Integer.compare(yearDiff(), other.yearDiff());
        return byYearDesc == 0 ? -level : byYearDesc;
    }

    public Integer yearDiff() {
        return eventType == NAME_DAY ? null : LocalDate.now().getYear() - eventDate.getYear();
    }

    public String formatDate() {
        return !dateKnown || eventType == NAME_DAY ? MonthDay.from(eventDate).toString() : eventDate.toString();
    }

}
