package pl.edu.amu.web.data;

import lombok.Builder;
import lombok.NonNull;
import lombok.Value;
import pl.edu.amu.entity.EventType;

import java.time.LocalDate;
import java.time.Year;
import java.time.YearMonth;

import static java.util.Objects.requireNonNull;

@Value
@Builder
public class PrayerEvent {

    @NonNull Long personId;
    @NonNull String displayName;
    LocalDate date;
    Year year;
    YearMonth yearMonth;
    EventType type;
    int level;

    public PrayerData toPrayerData() {
        requireNonNull(date, "Date may not be null in order to convert to PrayerData.");
        return PrayerData.builder()
                .eventDate(date).dateKnown(true)
                .personId(personId).displayName(displayName)
                .level(level)
                .eventType(type)
                .build();
    }

}
